// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_UK2Node.h"

#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{
	class ISCW_UEnum;
	class ISCW_UK2Node_CastByteToEnum : public virtual ISCW_UK2Node
	{
	public:
		virtual ~ISCW_UK2Node_CastByteToEnum() = default;

		virtual shared_ptr<ISCW_UEnum> GetEnum() const = 0;

		virtual void ReloadEnum(shared_ptr<ISCW_UEnum> InEnum) = 0;
		
		virtual std::shared_ptr<ISCW_UK2Node_CastByteToEnum> ToUK2Node_CastByteToEnumPtr() = 0;
		virtual std::shared_ptr<const ISCW_UK2Node_CastByteToEnum> ToUK2Node_CastByteToEnumPtr() const = 0;
	};

	using ISCW_UK2Node_CastByteToEnumConstPtr = std::shared_ptr<const ISCW_UK2Node_CastByteToEnum>;
	using ISCW_UK2Node_CastByteToEnumPtr = std::shared_ptr<ISCW_UK2Node_CastByteToEnum>;
} // namespace Sourcify